unit SvgEditIni;
//http://phidels.com

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,iniFiles,stdctrls,
  comctrls, Spin, Grids, ExtCtrls, CheckLst;

type
  TSvgEditIni = class(TComponent)
  private
    FSauveEdit           :boolean;
    FSauveDateTimePicker :boolean;
    FSauveCheckBox       :boolean;
    FSauveRadioButton    :boolean;
    FSauveSpinEdit       :boolean;
    FSauveMemo           :boolean;
    FSauveRichEdit       :Boolean;
    FSauveComboBox       :boolean;
    FSauveListBox        :boolean;
    FSauveStringGrid     :boolean;
    FSauveTrackBar       :boolean;
    FSauveChecklistBox   :boolean;

  protected
    FormAOwner:TForm;
    FormOldClose:TCloseEvent;
    procedure LaFormClose(Sender: TObject; var Action: TCloseAction);
    function ExisteComposantSvgEditSurLaFiche(Fiche:TForm) :Boolean;
    function RenvoiComposantSvgEditSurLaFiche(Fiche:TForm) :TSvgEditIni;
    procedure loaded; override;
  public
    IsLoaded:Boolean;
    Constructor Create(AOwner:TComponent); override;
    procedure ExecuteLecture;
    procedure ExecuteEcriture;
  published
    property SauveEdit           :boolean read FSauveEdit         write FSauveEdit;
    property SauveDateTimePicker :boolean read FSauveDateTimePicker   write FSauveDateTimePicker;
    property SauveCheckBox       :boolean read FSauveCheckBox     write FSauveCheckBox;
    property SauveRadioButton    :boolean read FSauveRadioButton  write FSauveRadioButton;
    property SauveSpinEdit       :boolean read FSauveSpinEdit     write FSauveSpinEdit;
    property SauveMemo           :boolean read FSauveMemo         write FSauveMemo;
    property SauveRichEdit       :boolean read FSauveRichEdit     write FSauveRichEdit;
    property SauveComboBox       :boolean read FSauveComboBox     write FSauveComboBox;
    property SauveListBox        :boolean read FSauveListBox      write FSauveListBox;
    property SauveChecklistBox   :boolean read FSauveChecklistBox write FSauveChecklistBox;
    property SauveStringGrid     :boolean read FSauveStringGrid   write FSauveStringGrid;
    property SauveTrackBar       :boolean read FSauveTrackBar     write FSauveTrackBar;
  end;

procedure Register;

implementation

procedure SauveTableauCheckedDansIni(FIni:TiniFile; SectionIni:string; CheckListBox:TCheckListBox);
var i:integer;
begin
   For i:=0 to CheckListBox.Items.Count do
   begin
      FIni.WriteBool(SectionIni,'L'+IntToStr(i), CheckListBox.Checked[i]);
   end;
end;

procedure LitTableauCheckedDeIni(FIni:TiniFile; SectionIni:string; CheckListBox:TCheckListBox);
var i:integer;
begin
 i:=0;
  while FIni.ValueExists (SectionIni, 'L'+IntToStr(i))do
  begin
    CheckListBox.Checked[i]:=(FIni.ReadBool(SectionIni,'L'+IntToStr(i),False));
    inc(i);
  end;
end;

procedure SauveTStringsDansIni(FIni:TiniFile; SectionIni:string; LeTStrings:TStrings; ItemIndex:integer);
{ permet de sauver dans un ini le contenu d'un mmo, d'un Combobox, d'un ListBox, d'un RichEdit}
{ et d'un faon gnrale, le contenu des composants qui le stocke dans des TStrings}
var
  i:integer;
begin
  Fini.EraseSection(SectionIni); // on efface toute la section dcrite par SectionIni
  for i:=0 to LeTStrings.Count-1 do // pour chaque ligne du Tstrings
  begin
    // on aura ainsi dans le fichier ini et dans la section considr :
    // L0= suivi du contenu de la premire ligne du TStrings. puis L1= etc..
     FIni.WriteString(SectionIni,'L'+IntToStr(i),LeTStrings[i]);// crit dans le fichier ini
  end;
  FIni.WriteInteger(SectionIni,'ItemIndex',ItemIndex);
end;


{permet de lire le contenu d'un ini qui a t sauv par SauveTStringsDansIni}
Procedure LitTstringsDeIni(FIni:TiniFile; SectionIni:string; LeTStrings:TStrings; var ItemIndex:integer);
Var
  i:integer;
begin
  LeTStrings.Clear;
  i:=0;
  while FIni.ValueExists (SectionIni, 'L'+IntToStr(i))do
  begin
    LeTStrings.Add(FIni.ReadString(SectionIni,'L'+IntToStr(i),''));
    inc(i);
  end;
  ItemIndex:=Fini.ReadInteger(SectionIni,'ItemIndex',0);
end;



procedure SauveTStringGridDansIni(FIni:TiniFile; SectionIni:string; Grille:TStringGrid);
Var  i,j:Integer;
Begin
  Fini.EraseSection(SectionIni); // on efface toute la section dcrite par SectionIni
  With Grille Do
    Begin
    FIni.WriteInteger(SectionIni,'COLCOUNT',ColCount);
    FIni.WriteInteger(SectionIni,'ROWCOUNT',RowCount);
    FIni.WriteInteger(SectionIni,'COL',Col);
    FIni.WriteInteger(SectionIni,'ROW',Row);
    FIni.WriteInteger(SectionIni,'TAG',Tag);
    For j:=0 To RowCount-1 Do For i:=0 To ColCount-1 Do
      If Trim(Cells[i,j]) <> '' Then
         FIni.WriteString(SectionIni,'C'+IntToStr(i)+'L'+IntToStr(j),Cells[i,j])
      Else
         If FIni.ValueExists(SectionIni,'C'+IntToStr(i)+'L'+IntToStr(j)) Then
            FIni.Deletekey  (SectionIni,'C'+IntToStr(i)+'L'+IntToStr(j));
    End;
End;



Procedure LitTstringGridDeIni(FIni:TiniFile; SectionIni:string; Grille:TStringGrid);
Var i,j:Integer;
Begin
  With Grille Do
     Begin
    // Test si la taille de la grille est incluse
    If FIni.ValueExists(SectionIni,'COLCOUNT')
    Then Begin
      ColCount := FIni.ReadInteger(SectionIni,'COLCOUNT',ColCount);
      RowCount := FIni.ReadInteger(SectionIni,'ROWCOUNT',RowCount);
      Col      := FIni.ReadInteger(SectionIni,'COL',Col);
      Row      := FIni.ReadInteger(SectionIni,'ROW',Row);
      Tag      := FIni.ReadInteger(SectionIni,'TAG',Tag);
      For j:=0 To RowCount-1 Do For i:=0 To ColCount-1 Do
        Cells[i,j] := FIni.ReadString(SectionIni,'C'+IntToStr(i)+'L'+IntToStr(j),'');
      End;
  End;
End;


Constructor TSvgEditIni.Create(AOwner:TComponent);
begin
  Inherited create(AOwner);
  IsLoaded           :=False;
  SauveEdit          :=True;
  SauveDateTimePicker:=True;
  SauveCheckBox      :=True;
  SauveRadioButton   :=True;
  SauveSpinEdit      :=True;
  SauveMemo          :=False;
  SauveRichEdit      :=False;
  SauveComboBox      :=False;
  SauveListBox       :=False;
  SauveCheckListBox  :=False;
  SauveStringGrid    :=False;
  SauveTrackBar      :=False;
  if not (csDesigning in ComponentState) then //si on est pas en mode conception
  begin
    if FormAOwner=Application.MainForm then
    begin
      FormAOwner:=TForm(AOwner);// la forme propritaire de notre composant
      FormOldClose:=FormAOwner.OnClose; //sauvegarde de l'vnement OnClose
      FormAOwner.OnClose:=LaFormClose; //idem pour OnClose
    end;
  end;
end;



procedure TSvgEditIni.loaded;
begin
  ExecuteLecture;
  inherited;
  IsLoaded:=True;
end;


procedure TSvgEditIni.LaFormClose(Sender: TObject; var Action: TCloseAction);
begin
  if assigned(FormOldClose)then FormOldClose(Sender,Action);
  ExecuteEcriture;
end;

function TSvgEditIni.RenvoiComposantSvgEditSurLaFiche(Fiche:TForm) :TSvgEditIni;
var j:integer;
begin
  Result:=nil;
  For j:=0 to Fiche.ComponentCount-1 do //pour chaque composant de la fiche
      if Fiche.Components[j] is TSvgEditIni then Result:=TSvgEditIni(Fiche.Components[j]);
end;

function TSvgEditIni.ExisteComposantSvgEditSurLaFiche(Fiche:TForm) :Boolean;
var j:integer;
begin
  Result:=false;
  For j:=0 to Fiche.ComponentCount-1 do //pour chaque composant de la fiche
      if Fiche.Components[j] is TSvgEditIni then Result:=true;
end;

procedure TSvgEditIni.ExecuteLecture;

var FIni:TiniFile;
    NomFic:string;
    i,j:integer;
    Fiche:TForm;
    SvgEditDeLaFiche:TSvgEditIni;
    Rien, valItemIndex :integer;

begin
  Rien:=0;
  NomFic:=ExtractFileName(application.ExeName);
  NomFic:=copy(NomFic,1,Length(NomFic)-4)+'.ini';
  FIni:=TiniFile.Create(NomFic);
  try
    For i:=0 to application.ComponentCount-1 do //pour chaque fiche de l'application
    begin
      if application.Components[i] is TForm then
      if ExisteComposantSvgEditSurLaFiche(TForm(application.Components[i])) then
      begin
        Fiche:=TForm(application.Components[i]);
        SvgEditDeLaFiche:= RenvoiComposantSvgEditSurLaFiche(Fiche);
        For j:=0 to Fiche.ComponentCount-1 do //pour chaque composant de la fiche
        begin
          if (Fiche.Components[j] is TEdit) and SvgEditDeLaFiche.SauveEdit then
          begin
            Try
              if FIni.ValueExists(Fiche.name,Fiche.Components[j].Name)
                 then Tedit(Fiche.Components[j]).Text
                 :=FIni.ReadString(Fiche.name,Fiche.Components[j].Name,'');
            Except
            end;
          end; // fin si c'est un Edit

          if (Fiche.Components[j] is TDateTimePicker)and SvgEditDeLaFiche.SauveDateTimePicker then
          begin
            try
              if FIni.ValueExists(Fiche.name,Fiche.Components[j].Name)
                 then TDateTimePicker(Fiche.Components[j]).DateTime
                 :=StrToDateTime( FIni.ReadString(Fiche.name,Fiche.Components[j].Name,''));
            except
            end;
          end;

          if (Fiche.Components[j] is TCheckBox) and SvgEditDeLaFiche.SauveCheckBox    then
          Try
            if FIni.ValueExists(Fiche.name,Fiche.Components[j].Name) then
            TCheckBox(Fiche.Components[j]).Checked:= FIni.ReadBool(Fiche.name,Fiche.Components[j].Name,true);
          Except
          end;

          if (Fiche.Components[j] is TRadioButton) and SvgEditDeLaFiche.SauveRadioButton then
          Try
            if FIni.ValueExists(Fiche.name,Fiche.Components[j].Name) then
            TRadioButton(Fiche.Components[j]).Checked:= FIni.ReadBool(Fiche.name,Fiche.Components[j].Name,true);
          Except
          end;

          if (Fiche.Components[j] is TSpinEdit) and SvgEditDeLaFiche.SauveSpinEdit    then
          begin
            try
              if FIni.ValueExists(Fiche.name,Fiche.Components[j].Name) then
              TSpinEdit(Fiche.Components[j]).Value:= FIni.ReadInteger(Fiche.name,Fiche.Components[j].Name,0);
            Except
            end;
          end;

          if (Fiche.Components[j] is TTrackBar) and SvgEditDeLaFiche.SauveTrackBar  then
          begin
            try
              if FIni.ValueExists(Fiche.name,Fiche.Components[j].Name) then
                TTrackBar(Fiche.Components[j]).Position
                    :=FIni.ReadInteger(Fiche.name,Fiche.Components[j].Name,0);
            Except
            end;
          end;

          if (Fiche.Components[j] is TMemo)  and SvgEditDeLaFiche.SauveMemo then
          begin
            try
              if FIni.SectionExists(Fiche.name+Fiche.Components[j].Name) then
              LitTstringsDeIni(FIni, Fiche.name+Fiche.Components[j].Name,TMemo(Fiche.Components[j]).Lines,rien );
            Except
            end;
          end;

          if (Fiche.Components[j] is TRichEdit) and SvgEditDeLaFiche.SauveRichEdit then
          begin
            try
              if FIni.SectionExists(Fiche.name+Fiche.Components[j].Name) then
              LitTstringsDeIni(FIni, Fiche.name+Fiche.Components[j].Name,TRichEdit(Fiche.Components[j]).Lines,rien);
            Except
            end;
          end;

          if (Fiche.Components[j] is TStringGrid) and SvgEditDeLaFiche.SauveStringGrid  then
          try
            if FIni.SectionExists(Fiche.name+Fiche.Components[j].Name) then
            LitTstringGridDeIni(FIni, Fiche.name+Fiche.Components[j].Name,TStringGrid(Fiche.Components[j]));
          Except
          end;

          if (Fiche.Components[j] is TComboBox) and SvgEditDeLaFiche.SauveComboBox    then
          begin
            try
              if FIni.SectionExists(Fiche.name+Fiche.Components[j].Name) then
              begin
                LitTstringsDeIni(FIni, Fiche.name+Fiche.Components[j].Name,TComboBox(Fiche.Components[j]).Items,valItemIndex);
                if valItemIndex<=TComboBox(Fiche.Components[j]).Items.Count-1 then TComboBox(Fiche.Components[j]).ItemIndex:=valItemIndex;
              end;
            Except
            end;
          end;

          if (Fiche.Components[j] is TListBox) and SvgEditDeLaFiche.SauveListBox  then
          begin
            try
              if FIni.SectionExists(Fiche.name+Fiche.Components[j].Name) then
              begin
                LitTstringsDeIni(FIni, Fiche.name+Fiche.Components[j].Name,TListBox(Fiche.Components[j]).Items,valItemIndex);
                if valItemIndex<=TListBox(Fiche.Components[j]).Items.Count-1 then TListBox(Fiche.Components[j]).ItemIndex:=valItemIndex;
              end;
            Except
            end;
          end;

          if (Fiche.Components[j] is TCheckListBox) and SvgEditDeLaFiche.SauveCheckListBox  then
          begin
            try
              if FIni.SectionExists(Fiche.name+Fiche.Components[j].Name) then
              begin
                LitTstringsDeIni(FIni, Fiche.name+Fiche.Components[j].Name,TCheckListBox(Fiche.Components[j]).Items,valItemIndex);
                if valItemIndex<=TCheckListBox(Fiche.Components[j]).Items.Count-1 then TCheckListBox(Fiche.Components[j]).ItemIndex:=valItemIndex;
                LitTableauCheckedDeIni(FIni,Fiche.name+Fiche.Components[j].Name+'Checked', TCheckListBox(Fiche.Components[j]));
              end;
            Except
            end;
          end;

        end; //fin for composant de la fiche
      end;//fin si c'est une fiche
    end; //fin pour chaque fiche de l'application
  finally
    Fini.Free;
  end;
end;

procedure TSvgEditIni.ExecuteEcriture;
var FIni:TiniFile;
    NomFic:string;
    i,j:integer;
    Fiche:TForm;
    SvgEditDeLaFiche:TSvgEditIni;
begin
  NomFic:=ExtractFileName(application.ExeName);
  NomFic:=copy(NomFic,1,Length(NomFic)-4)+'.ini';
  FIni:=TiniFile.Create(NomFic);
  try
    For i:=0 to application.ComponentCount-1 do //pour chaque fiche de l'application
    begin
      if application.Components[i] is TForm then
            if ExisteComposantSvgEditSurLaFiche(TForm(application.Components[i])) then
      begin
        Fiche:=TForm(application.Components[i]);
        SvgEditDeLaFiche:= RenvoiComposantSvgEditSurLaFiche(Fiche);
        For j:=0 to Fiche.ComponentCount-1 do //pour chaque composant de la fiche
        begin
          Try
            if (Fiche.Components[j] is TEdit)           and SvgEditDeLaFiche.SauveEdit
                   then FIni.WriteString(Fiche.name,Fiche.Components[j].Name,Tedit(Fiche.Components[j]).Text);
            if (Fiche.Components[j] is TDateTimePicker) and SvgEditDeLaFiche.SauveDateTimePicker then FIni.WriteString(Fiche.name,Fiche.Components[j].Name,DateTimeToStr(TDateTimePicker(Fiche.Components[j]).DateTime));
            if (Fiche.Components[j] is TCheckBox)       and SvgEditDeLaFiche.SauveCheckBox       then FIni.WriteBool(Fiche.name,Fiche.Components[j].Name,TCheckBox(Fiche.Components[j]).Checked);
            if (Fiche.Components[j] is TRadioButton)    and SvgEditDeLaFiche.SauveRadioButton    then FIni.WriteBool(Fiche.name,Fiche.Components[j].Name,TRadioButton(Fiche.Components[j]).Checked);
            if (Fiche.Components[j] is TSpinEdit)       and SvgEditDeLaFiche.SauveSpinEdit       then FIni.WriteInteger(Fiche.name,Fiche.Components[j].Name,TSpinEdit(Fiche.Components[j]).Value);
            if (Fiche.Components[j] is TMemo)           and SvgEditDeLaFiche.SauveMemo           then SauveTStringsDansIni(FIni, Fiche.name+Fiche.Components[j].Name,TMemo(Fiche.Components[j]).Lines,0);
            if (Fiche.Components[j] is TRichEdit)       and SvgEditDeLaFiche.SauveRichEdit       then SauveTStringsDansIni(FIni, Fiche.name+Fiche.Components[j].Name,TRichEdit(Fiche.Components[j]).Lines,0);
            if (Fiche.Components[j] is TComboBox)       and SvgEditDeLaFiche.SauveComboBox       then SauveTStringsDansIni(FIni, Fiche.name+Fiche.Components[j].Name,TComboBox(Fiche.Components[j]).Items,TComboBox(Fiche.Components[j]).ItemIndex);
            if (Fiche.Components[j] is TListBox)        and SvgEditDeLaFiche.SauveListBox        then SauveTStringsDansIni(FIni, Fiche.name+Fiche.Components[j].Name,TListBox(Fiche.Components[j]).Items,TListBox(Fiche.Components[j]).ItemIndex);
            if (Fiche.Components[j] is TCheckListBox)   and SvgEditDeLaFiche.SauveCheckListBox   then
            begin
              SauveTStringsDansIni(FIni, Fiche.name+Fiche.Components[j].Name,TCheckListBox(Fiche.Components[j]).Items,TCheckListBox(Fiche.Components[j]).ItemIndex);
              SauveTableauCheckedDansIni(FIni,Fiche.name+Fiche.Components[j].Name+'Checked', TCheckListBox(Fiche.Components[j]));
            end;
            if (Fiche.Components[j] is TStringGrid)     and SvgEditDeLaFiche.SauveStringGrid     then SauveTStringGridDansIni(FIni, Fiche.name+Fiche.Components[j].Name,TStringGrid(Fiche.Components[j]));
            if (Fiche.Components[j] is TTrackBar)       and SvgEditDeLaFiche.SauveTrackBar       then FIni.WriteInteger(Fiche.name,Fiche.Components[j].Name,TTrackBar(Fiche.Components[j]).Position);

          Except
          end;
        end; //fin for composant de la fiche
      end;//fin si c'est une fiche
    end; //fin pour chaque fiche de l'application
  finally
    Fini.Free;
  end;
end;



procedure Register;
begin
  RegisterComponents('Phidels', [TSvgEditIni]);
end;


end.
